# Here's a perl version which should run on any platform with both perl and ntpq (leap-check.pl):

# Terje
# - <Terje.Mathisen at tmsw.no> 

#!perl -w
use strict;

my $server = shift || die("Usage: leap-check.pl <server>\n");
my $cmd = sprintf('ntpq -c rv %s', $server);
my $rv = `$cmd`;
if (!($rv =~ /[\s,]leap=([01]{2})[\s,\n]/)) { die("No leap info found from server $server!\n"); }

my $leap = $1;
if ($leap eq '01' || $leap eq '10' || $leap eq '00') {
# Leap bits valid, locate the upstream sources!
  printf("%s: %s\n\n", $leap, $server);
  $cmd = sprintf('ntpq -c assoc %s', $server);
  my $assoc = `$cmd`;
  my $ind_to_expect = 1;
  foreach (split(/\n/, $assoc)) {
    my ($ind, $assid, @fields) = split;
    if (defined($ind) && $ind =~ /^\d+$/ && $ind == $ind_to_expect) {
      $cmd = sprintf('ntpq -c "rv %s" %s', $assid, $server);
      $rv = `$cmd`;
      my ($leap, $srcadr) = ('','');
      if ($rv =~ /leap=([01]{2})/) {
    $leap = $1;
      }
      if ($rv =~ /srcadr=([^,\s\n]+)[,\s\n]/) {
    $srcadr = $1;
      }
      printf("%s: %s\n", $leap, $srcadr);
      $ind_to_expect++;
    }
  }
}
